// WordHTMLView.cpp : implementation of the CWordHTMLView class
//

#include "stdafx.h"
#include "WordHTML.h"

#include "WordHTMLDoc.h"
#include "WordHTMLView.h"
#include ".\wordhtmlview.h"
#include "TOCTitleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CWordHTMLView
CString GetModuleDirectory();


IMPLEMENT_DYNCREATE(CWordHTMLView, CHtmlView)

BEGIN_MESSAGE_MAP(CWordHTMLView, CHtmlView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CHtmlView::OnFilePrint)
	ON_MESSAGE (WM_USER_GENERIC, OnUserGeneric)	
	ON_MESSAGE (WM_USER_NAVIGATE, OnUserNavigate)	
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_TOC_DONOTGENERATETOC, OnTocDonotgeneratetoc)
	ON_COMMAND(ID_TOC_GENERATETOC, OnTocGeneratetoc)
	ON_UPDATE_COMMAND_UI(ID_TOC_GENERATETOC, OnUpdateTocGeneratetoc)
	ON_UPDATE_COMMAND_UI(ID_TOC_DONOTGENERATETOC, OnUpdateTocDonotgeneratetoc)
	ON_COMMAND(ID_TABLEOFCONTENTS_TOCTITLE, OnTableofcontentsToctitle)
	ON_COMMAND(ID_TABLEOFCONTENTS_TOCFONT, OnTableofcontentsTocfont)
	ON_COMMAND(ID_TABLEOFCONTENTS_TOGGLETOC, OnTableofcontentsToggletoc)
	ON_UPDATE_COMMAND_UI(ID_TABLEOFCONTENTS_TOGGLETOC, OnUpdateTableofcontentsToggletoc)
END_MESSAGE_MAP()

// CWordHTMLView construction/destruction

CWordHTMLView::CWordHTMLView()
{
	// TODO: add construction code here
	navPath = _T("");
	goPath = _T("");

}

CWordHTMLView::~CWordHTMLView()
{	
	if (navPath!=_T(""))
				DeleteFile(navPath);
}

BOOL CWordHTMLView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CHtmlView::PreCreateWindow(cs);
}

LRESULT CWordHTMLView::OnUserGeneric(UINT wParam, LONG lParam) 
{

	if (navPath == _T(""))
	{

	}
	else
		Navigate2(navPath,NULL,NULL);	

	return 0;

}

LRESULT CWordHTMLView::OnUserNavigate(UINT wParam, LONG lParam) 
{

	if (goPath == _T(""))
	{

	}
	else
		Navigate2(goPath,NULL,NULL);	

	return 0;

}


void CWordHTMLView::OnInitialUpdate()
{
	CHtmlView::OnInitialUpdate();
	CString directoryX = GetModuleDirectory();
	CString pathx = directoryX + "\\initial.htm";	
	Navigate2(pathx,NULL,NULL);

	//Navigate2(_T("http://www.msdn.microsoft.com/visualc/"),NULL,NULL);
}


// CWordHTMLView printing



// CWordHTMLView diagnostics

#ifdef _DEBUG
void CWordHTMLView::AssertValid() const
{
	CHtmlView::AssertValid();
}

void CWordHTMLView::Dump(CDumpContext& dc) const
{
	CHtmlView::Dump(dc);
}

CWordHTMLDoc* CWordHTMLView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWordHTMLDoc)));
	return (CWordHTMLDoc*)m_pDocument;
}
#endif //_DEBUG


// CWordHTMLView message handlers


CString GetModuleDirectory()
{
	
	TCHAR    strPath[800];
	CString retPath;
	
	GetModuleFileName( NULL, strPath, 800 );
	
	CString modPath(strPath);	
	int fval = modPath.ReverseFind('\\');	
	retPath=modPath.Left(fval);
	
	return retPath;	

}

void CWordHTMLView::OnFileSaveAs()
{
	// TODO: Add your command handler code here
	ExecWB(OLECMDID_SAVEAS, OLECMDEXECOPT_DONTPROMPTUSER, NULL, NULL); 


}

void CWordHTMLView::OnTocDonotgeneratetoc()
{
	// TODO: Add your command handler code here
	CWordHTMLApp* app = (CWordHTMLApp*)  AfxGetApp();
	if (app)
	{
		app->m_opt_includeTOC = 0;


	}
}

void CWordHTMLView::OnTocGeneratetoc()
{
	// TODO: Add your command handler code here
	CWordHTMLApp* app = (CWordHTMLApp*)  AfxGetApp();
	if (app)
	{
		app->m_opt_includeTOC = 1;


	}
}

void CWordHTMLView::OnUpdateTocGeneratetoc(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	int check = 0;
	CWordHTMLApp* app = (CWordHTMLApp*)  AfxGetApp();
	if (app)
	{
		if (app->m_opt_includeTOC)
			check = 1;
	}
	pCmdUI->SetCheck(check);
}

void CWordHTMLView::OnUpdateTocDonotgeneratetoc(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	int check = 0;
	CWordHTMLApp* app = (CWordHTMLApp*)  AfxGetApp();
	if (app)
	{
		if (app->m_opt_includeTOC==0)
			check = 1;
	}
	pCmdUI->SetCheck(check);
}

void CWordHTMLView::OnTableofcontentsToctitle()
{
	// TODO: Add your command handler code here
	CWordHTMLApp* app = (CWordHTMLApp*)  AfxGetApp();
	if (app)
	{

		CTOCTitleDlg tocdDlg;
		tocdDlg.title = app->tocTitle;
		tocdDlg.format = app->tocFormat;
		tocdDlg.bullets = app->toc_bullets;
		if (tocdDlg.DoModal()==IDOK)
		{
			app->tocTitle =tocdDlg.title;  
			app->tocFormat = tocdDlg.format;
			app->toc_bullets = tocdDlg.bullets;

		}
	}

}

void CWordHTMLView::OnTableofcontentsTocfont()
{
	// TODO: Add your command handler code here
	CWordHTMLApp* app = (CWordHTMLApp*)  AfxGetApp();
	if (app)
	{
			CFontDialog fontDlg(&app->m_opt_TOCFont,CF_BOTH,0,this );
			
			//CFontDialog fontDlg;
			if (fontDlg.DoModal()==IDOK)
			{
				fontDlg.GetCurrentFont(&app->m_opt_TOCFont);   

			}

	}

	
}

void CWordHTMLView::OnTableofcontentsToggletoc()
{
	// TODO: Add your command handler code here
	CWordHTMLApp* app = (CWordHTMLApp*)  AfxGetApp();
	if (app)
	{
		if (app->m_opt_includeTOC==0)
			app->m_opt_includeTOC=1;
		else
			app->m_opt_includeTOC=0;
	}
}

void CWordHTMLView::OnUpdateTableofcontentsToggletoc(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	CWordHTMLApp* app = (CWordHTMLApp*)  AfxGetApp();
	if (app)
	{
		pCmdUI->SetCheck(app->m_opt_includeTOC);		
			
	}
	
}
